## libpthread-workqueue 0.8.2

=== Makefile ===
#
# Copyright (c) 2010 Mark Heily <mark@heily.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# 
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

# Flags to pass to dpkg-buildpackage
DPKGFLAGS=-uc -us

.PHONY :: install uninstall check dist dist-upload publish-www clean merge distclean fresh-build rpm edit cscope valgrind testing

include config.mk

all: $(PROGRAM).so testing

%.dll: $(OBJS)
	$(LD) -o $@ $(LDFLAGS) $(OBJS) $(LDADD)

%.o: %.c $(DEPS)
	$(CC) -c -o $@ $(CFLAGS) $<

$(PROGRAM).a: $(OBJS)
	$(AR) rcs $(PROGRAM).a $(OBJS)

$(PROGRAM).so: $(OBJS)
	$(LD) -shared $(LDFLAGS) $(OBJS) $(LDADD)
	$(LN) -sf $(PROGRAM).so.$(ABI_VERSION) $(PROGRAM).so
	$(LN) -sf $(PROGRAM).so.$(ABI_VERSION) $(PROGRAM).so.$(ABI_MAJOR)

install: $(PROGRAM).so
	$(INSTALL) -d -m 755 $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL) -d -m 755 $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m 644 $(HEADERS) $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL) -m 644 $(PROGRAM).so.$(ABI_VERSION) $(DESTDIR)$(LIBDIR)
	$(LN) -sf $(PROGRAM).so.$(ABI_VERSION) $(DESTDIR)$(LIBDIR)/$(PROGRAM).so.$(ABI_MAJOR)
	$(LN) -sf $(PROGRAM).so.$(ABI_VERSION) $(DESTDIR)$(LIBDIR)/$(PROGRAM).so
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man3
	$(INSTALL) -m 644 pthread_workqueue.3 $(DESTDIR)$(MANDIR)/man3/pthread_workqueue.3 

uninstall:
	rm -f $(INCLUDEDIR)/pthread_workqueue.h
	rm -f $(LIBDIR)/pthread_workqueue.so 
	rm -f $(LIBDIR)/pthread_workqueue.so.*
	rm -f $(LIBDIR)/pthread_workqueue.a
	rm -f $(MANDIR)/man3/pthread_workqueue.3 

reinstall: uninstall install
 
check: $(PROGRAM).so
	cd testing && make check

edit:
	$(EDITOR) `find ./src -name '*.c' -o -name '*.h'` Makefile

$(PROGRAM)-$(VERSION).tar.gz: 
	mkdir $(PROGRAM)-$(VERSION)
	cp Makefile ChangeLog configure config.inc $(MANS) $(PROGRAM)-$(VERSION)
	cp -R src testing include $(PROGRAM)-$(VERSION)
	find $(PROGRAM)-$(VERSION) -name '.svn' -exec rm -rf {} \; 2>/dev/null || true
	tar zcf $(PROGRAM)-$(VERSION).tar.gz $(PROGRAM)-$(VERSION)
	rm -rf $(PROGRAM)-$(VERSION)

testing:
	cd testing && make

dist: clean $(PROGRAM)-$(VERSION).tar.gz

%.asc:
	gpg --armor --detach-sign `echo '$@' | sed 's/.asc$$//'`

dist-upload: dist $(DISTFILE).asc
	scp $(DISTFILE) $(DISTFILE).asc heily.com:/var/www/heily.com/dist/$(PROGRAM)

publish-www:
	cp -R www/* ~/public_html/libkqueue/

clean:
	rm -f tags $(DISTFILE) $(DISTFILE).asc *.a $(OBJS) *.pc *.so *.so.* test-$(PROGRAM)
	cd testing && make clean
	rm -rf pkg

distclean: clean
	rm -f *.tar.gz config.mk config.h $(PROGRAM).pc $(PROGRAM).la rpm.spec
	rm -rf $(PROGRAM)-$(VERSION) 2>/dev/null || true

rpm: clean $(DISTFILE)
	rm -rf rpm *.rpm *.deb
	mkdir -p rpm/BUILD rpm/RPMS rpm/SOURCES rpm/SPECS rpm/SRPMS
	mkdir -p rpm/RPMS/i386 rpm/RPMS/x86_64
	cp $(DISTFILE) rpm/SOURCES 
	rpmbuild -bb rpm.spec
	mv ./rpm/RPMS/* .
	rm -rf rpm
	rmdir i386 x86_64    # WORKAROUND: These aren't supposed to exist
	fakeroot alien --scripts *.rpm

deb: clean $(DISTFILE)
	mkdir pkg
	cd pkg && tar zxf ../$(DISTFILE) && mv libpthread_workqueue-$(VERSION) libpthread-workqueue-$(VERSION)
	cp $(DISTFILE) pkg/libpthread-workqueue_$(VERSION).orig.tar.gz
	cp -R ports/debian pkg/libpthread-workqueue-$(VERSION) 
	cd pkg && \
	rm -rf `find libpthread-workqueue-$(VERSION)/debian -type d -name .svn` ; \
	perl -pi -e 's/\@\@VERSION\@\@/$(VERSION)/' libpthread-workqueue-$(VERSION)/debian/changelog ; \
	cd libpthread-workqueue-$(VERSION) && dpkg-buildpackage $(DPKGFLAGS)
	lintian -i pkg/*.deb
	@printf "\nThe following packages have been created:\n"
	@find ./pkg -name '*.deb' | sed 's/^/    /'

=== testing/CMakeLists.txt ===
#
# Copyright (c) 2011 Marius Zwicker <marius@mlba-team.de>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

#files
set(API api/test.c)
set(WITEM_CACHE witem_cache/test.c)
set(LATENCY latency/latency.c latency/latency.h)


#includes
include_directories(
	../include
)

if(UNIX)
    add_definitions(
        -DNO_CONFIG_H
    )
endif()

add_executable(test_api_pthread_workqueue ${API})
target_link_libraries(test_api_pthread_workqueue pthread_workqueue)
set_target_properties(test_api_pthread_workqueue PROPERTIES DEBUG_POSTFIX "D")

add_executable(test_latency_pthread_workqueue ${LATENCY})
target_link_libraries(test_latency_pthread_workqueue pthread_workqueue)

if(NOT WIN32)

        #add_executable(test_witem_cache_pthread_workqueue ${WITEM_CACHE})
        #target_link_libraries(test_witem_cache_pthread_workqueue pthreads_workqueue)

endif()

=== testing/Makefile ===
#
# Copyright (c) 2011 Mark Heily <mark@heily.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# 
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

# TODO: add libdispatch to TESTS

TESTS=api latency witem_cache
EXTRA_TESTS=idle

all clean check:
	for x in $(TESTS) ; do cd $$x && make $@ && cd .. ; done

extra-check:
	for x in $(EXTRA_TESTS) ; do cd $$x && make check && cd .. ; done

=== testing/api/Makefile ===
#
# Copyright (c) 2011 Mark Heily <mark@heily.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# 
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

.PHONY :: install uninstall check dist dist-upload publish-www clean merge distclean fresh-build rpm edit cscope valgrind

include ../../config.mk

all: test-$(PROGRAM)

test-$(PROGRAM): test.c
	$(CC) $(CFLAGS) -g -O0 -o test-$(PROGRAM) -I../.. -I../../include -L../.. test.c -lpthread_workqueue -lpthread

check: test-$(PROGRAM)
	LD_LIBRARY_PATH=../..:/usr/sfw/lib/amd64 ./test-$(PROGRAM)

debug: test-$(PROGRAM)
	LD_LIBRARY_PATH=../.. gdb ./test-$(PROGRAM)

valgrind: test-$(PROGRAM)
	valgrind --tool=memcheck --leak-check=full --show-reachable=yes --num-callers=20 --track-fds=yes ./test-$(PROGRAM)

clean:
	rm -f test-$(PROGRAM)

=== testing/idle/Makefile ===
#
# Copyright (c) 2011 Mark Heily <mark@heily.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# 
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

include ../../config.mk

all: idle

idle: main.c
	$(CC) $(CFLAGS) -g -O0 -o $@ -I../.. -I../../include -L../.. -Wl,-rpath,$(BASEDIR) main.c -lpthread_workqueue -lpthread

check: idle
	LD_LIBRARY_PATH=../..:/usr/sfw/lib/amd64 PWQ_DEBUG=yes ./idle

clean:
	rm -f idle

=== testing/latency/Makefile ===
CC=gcc

include ../../config.mk

all: latency

latency:
	$(CC) $(CFLAGS) -I../../include -L../.. -Wl,-rpath,$(BASEDIR) -o latency latency.c -lpthread_workqueue -lpthread -lrt

solaris:
	$(CC) $(CFLAGS) -I../../include -L../.. -R$(BASEDIR) -o latency latency.c -lpthread_workqueue -lpthread -lrt

macosx:
	$(CC) $(CFLAGS) -I../../include -L../.. -R$(BASEDIR) -o latencym latency.c -lpthread

check: latency
	LD_LIBRARY_PATH=../..:/usr/sfw/lib/amd64 ./latency

clean:
	rm -f latency
	rm -f latencym

=== testing/libdispatch/Makefile ===
CC=clang

dispatch_api:
	$(CC) -o dispatch_api dispatch_api.c -lpthread -lrt -ldispatch -lBlocksRuntime -lkqueue -lpthread_workqueue

check: dispatch_api
	./dispatch_api

clean:
	rm -f dispatch_api

=== testing/witem_cache/Makefile ===
#
# Copyright (c) 2011 Mark Heily <mark@heily.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# 
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

.PHONY :: install uninstall check dist dist-upload publish-www clean merge distclean fresh-build rpm edit cscope valgrind

include ../../config.mk

all: test-$(PROGRAM)

test-$(PROGRAM): test.c
	$(CC) $(CFLAGS) -g -O0 -o test-$(PROGRAM) -I../.. -I../../include -L../.. test.c -lpthread_workqueue -lpthread -lrt

check: test-$(PROGRAM)
	LD_LIBRARY_PATH=../..:/usr/sfw/lib/amd64 ./test-$(PROGRAM)

debug: test-$(PROGRAM)
	LD_LIBRARY_PATH=../.. gdb ./test-$(PROGRAM)

valgrind: test-$(PROGRAM)
	LD_LIBRARY_PATH=../..:/usr/sfw/lib/amd64 \
	valgrind --tool=memcheck --leak-check=full --show-reachable=yes --num-callers=20 --track-fds=yes ./test-$(PROGRAM)

clean:
	rm -f test-$(PROGRAM)

=== debian/changelog ===
libpthread-workqueue (0.8.2-1) unstable; urgency=low

  * New upstream version.
  * Fix FTBFS: use time_t instead of unsigned int (Closes: #633829)
  * Prevent a lintian warning caused by 'Author(s)' in debian/copyright 

 -- Mark Heily <mark@heily.com>  Sat, 16 Jul 2011 22:13:33 -0400

libpthread-workqueue (0.8.1-1) unstable; urgency=low

  * New upstream version.
  * Use LDADD instead of LDFLAGS (Closes: #631674)

 -- Mark Heily <mark@heily.com>  Sat, 09 Jul 2011 10:39:08 -0400

libpthread-workqueue (0.7-1) unstable; urgency=low

  * New upstream version.
      - Prevent deadlocks by implementing the overcommit attribute

 -- Mark Heily <mark@heily.com>  Mon, 13 Jun 2011 21:38:33 -0400

libpthread-workqueue (0.6-1) unstable; urgency=low

  * New upstream version.

 -- Mark Heily <mark@heily.com>  Fri, 20 May 2011 22:54:42 -0400

libpthread-workqueue (0.5.1-1) unstable; urgency=low

  * New upstream version.
  * Update control file with new Standards-Version.
  * Remove -m64 from CFLAGS (Closes: #622798)
  * Limit architecture to linux-any (Closes: #622799)

 -- Mark Heily <mark@heily.com>  Sat, 07 May 2011 11:57:22 -0400

libpthread-workqueue (0.4.1-1) unstable; urgency=low

  * Initial release (Closes: #616704)

 -- Mark Heily <mark@heily.com>  Sun, 13 Mar 2011 16:22:30 -0500

=== debian/control ===
Source: libpthread-workqueue
Priority: extra
Maintainer: Mark Heily <mark@heily.com>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.9.2
Section: libs
Homepage: http://mark.heily.com/proj/libpthread_workqueue
Vcs-Svn: svn://mark.heily.com/libpthread_workqueue/trunk

Package: libpthread-workqueue-dev
Section: libdevel
Architecture: linux-any
Depends: libpthread-workqueue0 (= ${binary:Version})
Description: thread pool library (development files)
 The pthread_workqueue library allows you to create one or more workqueues 
 and submit work items for processing. The workqueues are serviced by a 
 thread pool that is automatically created and dynamically managed by the 
 library.
 .
 This package contains files needed to build programs that use the 
 pthread_workqueue library.

Package: libpthread-workqueue0
Section: libs
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thread pool library
 The pthread_workqueue library allows you to create one or more workqueues 
 and submit work items for processing. The workqueues are serviced by a 
 thread pool that is automatically created and dynamically managed by the 
 library.
 . 
 The API is based on the pthread_workqueue API in FreeBSD 8.0, which was 
 designed to be compatible with the API developed by Apple Inc to support 
 the Grand Central Dispatch concurrency framework.

=== debian/rules ===
#!/usr/bin/make -f

%:
	CFLAGS="" LDADD="-lpthread" dh $@

## libpthread-workqueue 0.9.1

=== debian/changelog ===
libpthread-workqueue (0.9.1-1~mx25) mx; urgency=medium

  * Rebuild for MX 25.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Apr 2025 10:06:11 -0700

libpthread-workqueue (0.9.1-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * d/rules: disable auto tests, since they cause build to hang.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 01 Jul 2022 10:57:46 -0700

libpthread-workqueue (0.9.1-1) unstable; urgency=medium

  * New upstream version that prevents build failures on non-x86 platforms.

 -- Mark Heily <mark@heily.com>  Thu, 06 Mar 2014 23:38:54 -0500

libpthread-workqueue (0.9-1) unstable; urgency=low

  * New upstream version
  * Switch to using GNU autotools. (Closes: #724148)

 -- Mark Heily <mark@heily.com>  Sun, 02 Mar 2014 13:05:09 -0500

libpthread-workqueue (0.8-1) unstable; urgency=low

  * New upstream version.

 -- Mark Heily <mark@heily.com>  Sat, 09 Jul 2011 10:39:08 -0400

=== debian/control ===
Source: libpthread-workqueue
Priority: extra
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mark Heily <mark@heily.com>
Build-Depends: autotools-dev, debhelper (>= 10), dh-autoreconf
Standards-Version: 3.9.5.0
Section: libs
Homepage: https://github.com/mheily/libpwq/wiki
Vcs-Git: git://github.com/mheily/debian-packages.git -b libpthread_workqueue

Package: libpthread-workqueue-dev
Section: libdevel
Architecture: linux-any
Depends: libpthread-workqueue0 (= ${binary:Version}), ${misc:Depends}
Description: thread pool library (development files)
 The pthread_workqueue library allows you to create one or more workqueues
 and submit work items for processing. The workqueues are serviced by a
 thread pool that is automatically created and dynamically managed by the
 library.
 .
 This package contains files needed to build programs that use the
 pthread_workqueue library.

Package: libpthread-workqueue0
Section: libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: thread pool library
 The pthread_workqueue library allows you to create one or more workqueues
 and submit work items for processing. The workqueues are serviced by a
 thread pool that is automatically created and dynamically managed by the
 library.
 .
 The API is based on the pthread_workqueue API in FreeBSD 8.0, which was
 designed to be compatible with the API developed by Apple Inc to support
 the Grand Central Dispatch concurrency framework.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_test:
